﻿Type=Service
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private astream As AsyncStreams
	Private socket As Socket
	Public connected As Boolean
	Private watchdog As Timer
	Private lastValueTime As Long
	Private ser As B4RSerializator
End Sub

Sub Service_Create
	watchdog.Initialize("watchdog", 1000)
	ser.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub Connect(ip As String)
	If astream.IsInitialized Then
		astream.Close
	End If
	socket.Initialize("socket")
	socket.Connect(ip, 51042, 30000)
End Sub

Private Sub Socket_Connected (Successful As Boolean)
	If Successful Then
		connected = True
		astream.InitializePrefix(socket.InputStream, False, socket.OutputStream, "astream")
		CallSub(Main, "StateChanged")
		watchdog.Enabled = True
		lastValueTime = DateTime.Now
	End If
End Sub

Private Sub Astream_NewData (Buffer() As Byte)
	CallSub2(Main, "NewValue", ser.ConvertBytesToArray(Buffer))
	lastValueTime = DateTime.Now
	astream.Write(ser.ConvertArrayToBytes(Array("Sent from B4A", DateTime.Time(DateTime.Now), True)))
End Sub

Private Sub Astream_Error
	Log("Disconnected")
	connected = False
	CallSub(Main, "StateChanged")
	watchdog.Enabled = False
End Sub

Private Sub Astream_Terminated
	Astream_Error
End Sub

Private Sub Watchdog_Tick
	If DateTime.Now - lastValueTime > 10 * DateTime.TicksPerSecond Then
		Log("Watchdog closing connection.")
		If astream.IsInitialized Then astream.Close
		Astream_Error
	End If
End Sub

Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
